<!DOCTYPE html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width">
		<title>matrix-site</title>
		<script>
		/* first, before importing `mwc` (in a seprate script),
			 we need to prevent it to register the web-components in the browser API,
			 so we can define matrix custom events before they load.
			 (We will manually define the web-components at the end of the script).
		 */
		window.MWC_MANUAL_DEFINE
		</script>

		<script type="module">
		/* we can import the javascript library from a CDN */
		import mwc from "https://unpkg.com/@sctlib/mwc"

		/* a display template, is a web-component that we define late;
			 it will accept a `event` attribute with its JSON stringified value */
		const customEventDisplayTemplate = document.createElement("template");
		customEventDisplayTemplate.innerHTML = `<ugrp-post></ugrp-post>`;

		/* there are two ways of loading templates (form or display) */
		mwc.eventsManager.registerEventType('io.gitlab.ugrp.post', {
			displayTemplate: customEventDisplayTemplate,
			formTemplate: document.querySelector('template')
		});

		/* now that the custom event is defined,
			 we can manually register all `matrix-*` web components from `mwc` */
		mwc.defineComponents(mwc.componentDefinitions);
		</script>
		<script>
		/* a custom web component to render a custo matrix event,
			 registered in our event's `displayTemplate` (as sole children) */
		class UgrpPost extends HTMLElement {
			/* we always get the value of the `event` as a JSON stringified object */
			get event() {
				return JSON.parse(this.getAttribute('event'))
			}
			/* web component lifecycle webhook, inserted in the DOM */
			connectedCallback() {
				/* START of our personal web-component logic */
				this.render()
			}
			render() {
				/* SECURITY: always take care of using `innerHTML`,
					 when our components display user generated content. */
				this.innerHTML = '';
				const $doms = this.createDoms()
				this.append(...$doms)
			}
			createDoms() {
				/* we should always use `document.createElement()`, and `dompurify`;
					 (also see `flag-sanitizer` in the docs) */
				const $title = document.createElement('h1')
				$title.innerText = this.event.content.title
				const $text = document.createElement('div')
				$text.innerText = this.event.content.text
				return [$title, $text]
			}
		}
		/* register our custom element (if not already)
			 @NOTE: this is exactly what the `mwc.defineComponents()` step does,
			 for the `mwc` components (hence why manually done as the last step,
			 so when they load, they know of our new custom event.s)
		 */
		if (!customElements.get('ugrp-post')) {
			customElements.define('ugrp-post', UgrpPost)
		}
		</script>
	</head>
	<body>
		<body-header>
			<h1>matrix-site</h1>
			<p>This site's content is sourced from events in the <a href="https://matrix.to/#/#mwc-chat:matrix.org">#mwc-chat:matrix.org</a> room. To create a new post, join the room as guest user, or login with a registered matrix account (use a "test account" for better security, since this page has user generated content).</p>
			<details>
				<summary>About</summary>
				<p>This example site shows a community generated message board built on the <a href="https://matrix.org/">matrix</a> protocol and decentralized ecosystem (all components are in early development stage, reload the page after joining the room for the UI to correctly show).</p>
				<p>It showcases how to use <a href="https://gitlab.com/sctlib/mwc">@sctlib/mwc</a> to create custom matrix events and their content (with form & display templates), in a few lines of 100% 🍦 idiomatic HTML, CSS and Javascript web languages.</p>
				<p>On this page, a new post is a custom event of type <code>io.gitlab.ugrp.post</code> sent in the room <code>#mwc-chat:matrix.org</code> (cannot yet be edited here, to delete, use an other client with "developer mode" activated in the interface).</p>
				<p>This matrix room is setup (via the <a href="https://element.io/">element</a> web client) to authorize anyone including guests, to post events in the room. Feel free to publish any messages and tests (as long as it follows the <a href="https://matrix.org/about">matrix code of conduct and manifesto</a>).</p>
				<p>See the <a href="https://gitlab.com/ugrp/tests/matrix-site">code and documentation</a> for more details.</p>
			</details>
		</body-header>
		<body-aside>
			<details>
				<summary>Auth</summary>
				<matrix-auth show-guest="true" show-user="true">
					<matrix-login slot="logged-out"></matrix-login>
					<matrix-logout slot="logged-in"></matrix-logout>
				</matrix-auth>
			</details>
		</body-aside>
		<body-main>
			<matrix-room
				profile-id="#mwc-chat:matrix.org"
				origin="https://matrix.to/#/"
				show-context="true"
				show-room-actions="true"
				show-send-event="true"
				show-event-sender="true"
				show-event-info="true"
				send-event-types='["io.gitlab.ugrp.post"]'
				filter='{"types":["io.gitlab.ugrp.post"]}'
			></matrix-room>
		</body-main>

		<!-- the custom matrix events "keys" are the "named inputs";
				 our data model into matrix `event.content.*` -->
		<template>
			<h2>Create new post message</h2>
			<p>Write a title and text for the post to publish on this site (and matrix room, as the guest or logged in matrix user).</p>
			<form>
				<fieldset>
					<legend>Title</legend>
					<input name="title" placeholder="Post's title" required="true"/>
				</fieldset>
				<fieldset>
					<legend>Text</legend>
					<textarea name="text" placeholder="Post's text content" required="true"
					></textarea>
				</fieldset>
				<fieldset>
					<button type="submit">Create new post</button>
				</fieldset>
			</form>
		</template>

		<style>
		/* (styles are put at the bottom for clarity of file reading)
			 There are no CSS classes,
			 only custom HTML elements and "state" attributes.
			 Also CSS native nesting works in all brwosers, and we can use variables
		 */
		/*
			 universal box sizing (so padding and margin are easier to reason about,
			 https://css-tricks.com/box-sizing/#aa-universal-box-sizing-with-inheritance) */
		html {
			box-sizing: border-box;
		}
		*, *:before, *:after {
			box-sizing: inherit;
		}
		/* variables */
		:root {
			--line-height: 1.4;
			--font-size: 19px;
			--s: 0.5rem;
			--s-container: 70rem;
		}
		/* variables for user OS/browser themes */
		@media (prefers-color-scheme: dark) {
			:root,
			:host {
				color-scheme: dark;
				--c-link: turquoise;
				--c-fg: white;
				--c-bg: black;
			}
		}
		@media (prefers-color-scheme: light) {
			:root,
			:host {
				color-scheme: light;
				--c-link: green;
				--c-fg: black;
				--c-bg: lightgray;
			}
		}
		/* site layout */
		html {
			font-size: var(--font-size);
			line-height: var(--line-height);
			background-color: var(--c-bg);
		}
		html,
		body,
		body-header,
		body-main,
		body-aside {
			display: flex;
			flex-direction: column;
			width: 100%;
		}
		body {
			margin: 0;
			max-width: var(--s-container);
			align-self: center;
		}
		body-header,
		body-main,
		body-aside {
			padding: var(--s);
		}

		/* typography */
		a {
			color: var(--c-link);
		}
		h1,
		h2,
		h3
		p {
			margin-top: 0;

		}
		h1,
		h2,
		h3,
		matrix-room-name,
		ugrp-post h1 {
			margin-bottom: 0;
			font-weight: bold;
			font-size: 1.5rem;
			line-height: 1;
		}
		code {
			white-space: pre-wrap;
			word-break: break-word;
			background-color: var(--c-link);
			color: var(--c-bg);
			padding: calc(var(--s) / 3);
		}
		details {
			&[open] {
				background-color: var(--c-bg);
				summary {
					text-decoration: underline;
				}
			}
			summary {
				cursor: pointer;
			}
		}

		/* (mwc) login and room */
		matrix-login,
		matrix-room {
			input,
			textarea,
			button,
			select {
				padding: calc(var(--s) / 2);
				/* @TODO: so matrix-login (broken, no fieldset) form also has
					 "nice styles" */
				margin: 0.1rem;
			}
			textarea {
				resize: vertical;
			}
			fieldset {
				margin-bottom: var(--s);
				display: flex;
			}
		}
		matrix-room {
			display: flex;
			flex-direction: column;

			input,
			textarea {
				flex-grow: 1;
				color: var(--c-fg);
			}
			slot[name="state"] {
				display: flex;
				flex-direction: column;
				margin-bottom: calc(var(--s) * 2);
			}
		}
		matrix-room-context button[dir="after"] {
			display: none;
		}
		matrix-room-state {
			display: flex;
			flex-direction: column;
		}
		matrix-room-topic {
			font-style: italic;
		}

		/* login */
		matrix-login {
			form {
				display: flex;
				flex-direction: column;
			}
		}
		/* send event(s) */
		matrix-send-event {
			padding: calc(var(--s) * 2);
		}
		/* one event */
		matrix-event {
			display: flex;
			flex-direction: column-reverse;
			padding: calc(var(--s) * 2);
		}
		matrix-event-state {
			display: flex;
			flex-wrap: wrap;
			justify-content: space-between;
		}
		/* avatar image */
		matrix-avatar {
			display: inline-flex;
			max-width: calc(var(--s) * 15);
			margin: var(--s);
			img {
				display: block;
				max-width: 100%;
			}
		}
		</style>
	</body>
</html>
